var Browser = window.navigator.userAgent;

var re_ie  = new RegExp("(msie 5\.[5-9])|(msie [6-7]\.[0-9])",'i');
var re_ope = new RegExp("(opera)","i");
var re_moz = new RegExp("(^mozilla\/5\.0)(.*)","i");

var isSource = new Array();

if (re_ie.test(Browser) && !re_ope.test(Browser)) {
  Browser = 1;
} else if (re_moz.test(Browser)) {
  Browser = 2;
} else {
  Browser = 3;
}

function init(name) {
  if (!document.getElementById) {
    alert('javascript error');
    return;
  }

  var ta = document.getElementById('text_'+name);
  var ra = document.getElementById('rich_'+name);
  switch(Browser) {
    case 1: // MSIE
      ra.innerHTML=ta.value;
      ra.className='richarea';
      ta.className='hidden';
      ra.focus();

      isSource[name] = false;
    break;
    case 2: // mozilla
      ra.className='richarea';
      ra.contentWindow.document.open();
      ra.contentWindow.document.write('<html><head></head><body>'+ta.value+'</body></html>');
      ra.contentWindow.document.close();
      ra.contentWindow.document.designMode = "on";
      ra.contentWindow.focus();

      ta.className='hidden';
      isSource[name] = false;
    break;
    default:
    break;
  }
}

function init_btn(name) {
  var btn_box = document.getElementById('btn_'+name);
  switch(Browser) {
    case 1: // MSIE
    case 2: // mozilla
      btn_box.className = 'vissible';
    break;
    default:
    break;
  }
}

function source_rich(name) {

  try {
  var ta = document.getElementById('text_'+name);
  var ra = document.getElementById('rich_'+name);
  var btn_box = document.getElementById('btn_'+name);
  var html;

  switch(Browser) {
    case 1:
      if (isSource[name]) {
        btn_box.className = 'vissible';
        ra.innerHTML=ta.value;
        ra.className='richarea';
        ta.className='hidden';
        ra.focus();
      } else {
        btn_box.className = 'hidden';
        ta.value=ra.innerHTML;
        ta.className='textarea';
        ra.className='hidden';
        ta.focus();
      }
      isSource[name] = !isSource[name];
    break;
    case 2:

      if (isSource[name]) {

        html = ra.contentWindow.document.body.ownerDocument.createRange();
        html.selectNodeContents(ra.contentWindow.document.body);
        ra.contentWindow.document.body.innerHTML = html.toString();

        btn_box.className = 'vissible';

   } else {
        html = ra.contentWindow.document.createTextNode(ra.contentWindow.document.body.innerHTML);
        ra.contentWindow.document.body.innerHTML = "";
        ra.contentWindow.document.body.appendChild(html);

        btn_box.className = 'hidden';
      }

      isSource[name] = !isSource[name];
    break;
    default:
    break;
  }
  } catch (e) {
    alert ("an exception occured:\n" + e);
  }
  return false;
}


function ed_btn(btn, name) {
  var ra = document.getElementById('rich_'+name);
  switch(Browser) {
    case 1: // MSIE
      ra.focus();
      document.execCommand(btn);
    break;
    case 2: // mozilla
      var szURL = null;
      if (btn == 'CreateLink') {

        if ((typeof ra.contentWindow.getSelection() == 'undefined') ||
            (ra.contentWindow.getSelection().getRangeAt(0) == "")) {
          alert('Select part of text!');
          return false;
        }
        szURL = prompt("Enter a URL:", "http://");
        if (szURL == null) { 
           return false;
        }
      }

      ra.contentWindow.document.execCommand(btn,false,szURL);
      ra.contentWindow.focus();
    break;
    default:
    break;
  }
  return false;
}

function save_allRichArea() {
  switch(Browser) {
    case 1: // MSIE
      for (key in isSource) {
	if (!isSource[key]) {
          source_rich(key);
        }
      }
    break;
    case 2: // mozilla
      for (key in isSource) {
        var ta = document.getElementById('text_'+key);
        var ra = document.getElementById('rich_'+key);
	if (!isSource[key]) {
          ta.value = ra.contentWindow.document.body.innerHTML;
        } else {
          var html = ra.contentWindow.document.body.ownerDocument.createRange();
          html.selectNodeContents(ra.contentWindow.document.body);
          ta.value = html.toString();
        }
      }
    break;
    default:
    break;
  }
  return true;
}