<?php
require('./init.php');

$strings = array (
  'cs' => array(
    'wiki/authentication' => 'wiki/přihlášení',
    'user name' => 'přihlašovací jméno',
    'password' => 'heslo',
    'authentication failed' => 'přihlašení se nezdařilo',
    'view' => 'zobrazit'
  )
);

  function randstr($minlen = 3, $maxlen = 10) {
    $min =  96;
    $max = 122;
    $str = '';
    for ($i = rand($minlen, $maxlen); $i > 0; $i--) {
      $str .= chr(rand($min,$max));
    } 
    return $str;
  }


$page = isset ($_REQUEST['page']) ? $_REQUEST['page'] : 'home';
$title = getI18n( "wiki/authentication", $lang);
$username_str = getI18n("user name", $lang);
$password_str = getI18n("password", $lang);



$error_str = "";

if (isset($_REQUEST['user'])) {

  if (($_REQUEST['user'] == $config_data['user']) &&
      ($_REQUEST['hash'] == sha1($config_data['sha1'].$_SESSION['salt']) )) {

        $_SESSION['login'] = $_REQUEST['user'];
        header("location: wiki.php?page=$page");
        exit();
      } else {
        $error_str = "<span style=\"color: red\">".getI18n("authentication failed", $lang)."</span>";
      }
}

$salt = $_SESSION['salt'] = randstr(3,4).time();


$content = <<<EOF

<script type="text/javascript" src="sha1.js" ></script>
 <script type="text/javascript">
   function secure_form(myform) {
       myform.hash.value = hex_sha1(hex_sha1(myform.password.value) + '$salt');
       myform.password.value = '';
       return true;
   }
 </script>

<form action="login.php" method="post" onsubmit="return secure_form(this)">

<table class="loginfield">
  <tr>
    <td>$username_str </td> 
    <td> <input type="text" name="user"/> </td>
  </tr>
  <tr>
    <td> $password_str </td>
    <td> <input type="password" name="password"/> </td>
  </tr>
  <tr>
    <td colspan="2"> 
       <input type="submit" value="login"/>
    </td>
  </tr>
</table>
<input type="hidden" name="page" value="$page" />
<input type="hidden" name="hash" value="" />

</form>

$error_str
EOF;


$view_str = getI18n("view", $lang);

$content .= <<<EOF
<div style="text-align:right;">
<a href="wiki.php?page=$page" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif"> $view_str </a>
</div>
EOF;



require('./template.php');
?>
