<?php
require('init.php');
require('wikiContent.php');

$page = isset($_GET['page']) ? $_GET['page'] : "home";

$title= "wiki/".$page;
$dts = isset($_REQUEST['unixdts']) ? $_REQUEST['unixdts'] : NULL;
$dts_query = (isset($dts)) ? "&amp;unixdts=$dts" :  "";
$data = getWikiContent($page, $lang, $dts);
$update = $data['dts'];
$content = $data['content'];

$strChanges = getI18n('changes', $lang);
$strTopics =  getI18n('topics', $lang); 
$strEdit = getI18n('edit', $lang);
$content .= <<<EOF
<br/> 
<div style="text-align:right; ">
<span style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif">$update</span>
<a href="./wikiChanges.php?page=$page$dts_query" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif">$strChanges</a>
<a href="./wikiList.php" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif">$strTopics</a>
<a href="./wikiEdit.php?page=$page" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif">$strEdit</a>
</div>
EOF;

/*
<a href="./wikiEdit.php?page=$page" style= "color: #7f7f7f; font-size: 80%; font-family: Arial, Helvetica, Sans-Serif; text-decoration: none">&pi;</a>

*/

require('template.php');

?>
